
# THIS SCRIPT IS LICENSED UNDER GPL,
# please read the license block.
#
# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####

bl_info = {
	"name": "Add Node Material",
	"author": "",
	"version": (1, 0),
	"blender": (2, 78, 0),
	"location": "View 3d > Properties > Material",
	"description": "Add a new material using a node group.",
	"warning": "",
	"wiki_url": "",
	"category": "Node",
} 


import bpy



class NodeMaterialPreferences(bpy.types.AddonPreferences):
	bl_idname = "add_nodegroup_materials4" 


	used_default_nodegroup = bpy.props.BoolProperty(
	   name='Use Default?',
	   description ='Click to choose a default node group.',
	   default=False,
	)

	material_nodegroup = bpy.props.StringProperty(
	   name='Node Group',
	   description ='Select the node group to use',
	)

			
	def draw(self, context):
		layout = self.layout
		act_obj = bpy.context.active_object
		row = layout.row(align=True)
		row.prop(self, "used_default_nodegroup")
		if self.used_default_nodegroup == True:
			row = layout.row(align=True)
			row.prop(act_obj, "save_nodegroup")   
			row = layout.row(align=True)
			row.prop_search(self, "material_nodegroup", bpy.data, "node_groups", text= 'Default Node Group')

##################################################################################################

panel_type = "Cycles_PT_context_material"

def draw_nodegroup_settings(self, context):
	layout = self.layout

	act_obj = bpy.context.active_object
	preferences = context.user_preferences.addons["add_nodegroup_materials4"].preferences
	act_mat = bpy.context.active_object.active_material
	
					
	if context.scene.render.engine == 'CYCLES': 
		if preferences.used_default_nodegroup == False and act_mat == None:
			col = layout.column(align=True)
			col = layout.column(align=True)
			if preferences.material_nodegroup != '' and context.object.material_name == '':
				col.operator("material.node_material", text= 'New ' + preferences.material_nodegroup + ' Material', icon= 'MATERIAL_DATA')
				row = layout.column(align= True)
				row.prop(act_obj, "material_name")   
				row.prop_search(preferences, "material_nodegroup", bpy.data, "node_groups")


			if preferences.material_nodegroup != '' and context.object.material_name != '':
				col.operator("material.node_material", text= 'New ' + context.object.material_name + ' Material', icon= 'MATERIAL_DATA')

				row = layout.column(align= True)
				row.prop(act_obj, "material_name")   
				row.prop_search(preferences, "material_nodegroup", bpy.data, "node_groups")


			if preferences.material_nodegroup == '':
				col1 = layout.column(align=True)	
				col1.label('Must have a node group selected!', icon= 'ERROR')   
				col.enabled = False 
				col.operator("material.node_material", text= 'New Node Group Material', icon= 'MATERIAL_DATA')
				col = layout.column(align= True)   
				col.prop_search(preferences, "material_nodegroup", bpy.data, "node_groups")


			my_node = bpy.data.node_groups[preferences.material_nodegroup]

			for i in my_node.outputs:
				print('')

			if 'RGBA' in i.type:
				row.label("Selected node group has a RGBA output!")
			if 'RGBA' in i.type and 'VALUE' in i.type:
				row.label("Selected node group has a RGBA output!") 
			if 'SHADER' in i.type:
				row.label("Selected node group has a Shader output!")
			if 'SHADER' and 'VALUE' in i.type:
				row.label("Selected node group has a Shader output!")

				

		if preferences.used_default_nodegroup == True and act_mat == None:
			col = layout.column(align=True)
			col = layout.column(align=True)
			if preferences.material_nodegroup != '':
				col.operator("material.node_material", text= 'New ' + preferences.material_nodegroup + ' Material', icon= 'MATERIAL_DATA')
			if preferences.material_nodegroup == '':
				col.enabled = False 
				col.operator("material.node_material", text= 'New Node Group Material', icon= 'MATERIAL_DATA')
			if preferences.material_nodegroup == '':
				col1 = layout.column(align=True)	
				col1.label('Must have a node group selected!', icon= 'ERROR')  
			row = layout.row(align= True)
			row.prop(act_obj, "change_nodegroup")


			if preferences.material_nodegroup != '':
				col = layout.column(align= True)
				col.enabled = False
				col.prop(preferences, "material_nodegroup", text='Default Node Group')

			my_node = bpy.data.node_groups[preferences.material_nodegroup]

			for i in my_node.outputs:
				print('')


			col1 = layout.column(align= True)
			col1.enabled = True
			if 'RGBA' in i.type:
				col1.label("Selected node group has a RGBA output!")
			if 'RGBA' in i.type and 'VALUE' in i.type:
				col1.label("Selected node group has a RGBA output!")	
			if 'SHADER' in i.type:
				col1.label("Selected node group has a Shader output!")
			if 'SHADER' and 'VALUE' in i.type:
				col1.label("Selected node group has a Shader output!")

			
	
	if context.scene.render.engine != 'CYCLES': 
		col = layout.column(align=True)
		col.label('Addon only works for cycles!', icon= 'ERROR')  
 
##################################################################################################
class NodeMaterialPanel(bpy.types.Panel):
	"""Creates a Panel in the Material properties window"""
	bl_label = "Add Node Material"
	bl_idname = "OBJECT_node_material"
	bl_space_type = 'PROPERTIES'
	bl_region_type = 'WINDOW'
	bl_context = "material"


	draw = draw_nodegroup_settings

##################################################################################################
  
class NodeGroupMessageOperator(bpy.types.Operator):
	bl_idname = "nodegroup.errormessage"
	bl_label = "Error"


	def invoke(self, context, event):
		wm = context.window_manager
		return wm.invoke_popup(self, width=250, height=50)
		return {'FINISHED'}

	def draw(self, context):
		layout = self.layout
		layout.label(text = "There is no node group with this name!", icon = "ERROR")

##################################################################################################

class NodeMaterialOperator(bpy.types.Operator):
	"""Add a new material with the selected / default node group"""
	bl_idname = "material.node_material"
	bl_label = "New Node Group Material"


	def execute(self, context):
	
		preferences = context.user_preferences.addons["add_nodegroup_materials4"].preferences  
		material_name = context.object.material_name
		nodegroup_name = preferences.material_nodegroup
		act_obj = bpy.context.active_object
  

		if nodegroup_name not in bpy.data.node_groups:
			bpy.ops.nodegroup.errormessage('INVOKE_DEFAULT')
			return {'CANCELLED'}
		
		if preferences.used_default_nodegroup == False and material_name != '':  
			material = bpy.data.materials.new(name= material_name)
			
		if preferences.used_default_nodegroup == False and material_name == '':
			material_name = preferences.material_nodegroup  
			material = bpy.data.materials.new(name= material_name)

		if preferences.used_default_nodegroup == True:
			material_name = preferences.material_nodegroup  
			material = bpy.data.materials.new(name= material_name)  

		if preferences.material_nodegroup == '':
			material_name = 'Material' 
			material = bpy.data.materials.new(name= material_name)

			
		material.use_nodes = True


		material.node_tree.nodes.remove(material.node_tree.nodes.get('Diffuse BSDF'))
		material_output = material.node_tree.nodes.get('Material Output')


		if preferences.material_nodegroup != '':
			group = material.node_tree.nodes.new("ShaderNodeGroup")
			group.node_tree = bpy.data.node_groups[nodegroup_name]
			my_node = group.node_tree   

			group.location = (-200,0)   
			bpy.context.active_object.active_material = material

			for i in my_node.outputs:
				#If 'Surface' in group node outputs, connect (Material Ouput) input(Surface) to goup node output(Surface)   
				if i.type == 'SHADER' and 'Surface' in i.name:
					material.node_tree.links.new(material_output.inputs[0], group.outputs['Surface'])


				#If 'Shader' in group node outputs, connect (Material Ouput) input(Surface) to goup node output(Shader)
				if i.type == 'SHADER' and 'Shader' in i.name:
					material.node_tree.links.new(material_output.inputs[0], group.outputs['Shader'])


				#If 'Volume' in group node outputs, connect (Material Ouput) input(Volume) to goup node output(Volume)
				if i.type == 'SHADER' and 'Volume' in i.name:
					material.node_tree.links.new(material_output.inputs[1], group.outputs['Volume'])				
				if i.type == 'SHADER' and 'Volume' not in i.name:
					material.node_tree.links.new(material_output.inputs[0], group.outputs[0])


				#If 'Displacement' in group node outputs, connect (Material Ouput) input(Displacement) to goup node output(Displacement)
				if i.type == 'VALUE' and 'Displacement' in i.name:
					material.node_tree.links.new(material_output.inputs[2], group.outputs['Displacement'])



#If output type on node group is 'RGBA' and not 'SHADER'
			if my_node.outputs[0].type == 'RGBA':   
				diffuse_material = material.node_tree.nodes.new('ShaderNodeBsdfDiffuse')	
				material.node_tree.links.new(material_output.inputs[0], diffuse_material.outputs[0])
				diffuse_material.location = (50,100)
				group.location = (-300,0)
				material.node_tree.links.new(diffuse_material.inputs[0], group.outputs[0])
				bpy.context.active_object.active_material = material

				for i in my_node.outputs:
					if i.type == 'VALUE' and 'Displacement' in i.name:
						material.node_tree.links.new(material_output.inputs[2], group.outputs['Displacement'])   




		context.object.material_name = ''
		
#Assign material to mesh if in edit mode
		if act_obj.mode == 'EDIT':
			bpy.ops.object.material_slot_assign()   
		

		return {'FINISHED'}
##################################################################################################  
def change_nodegroups(self, context):
	
	preferences = context.user_preferences.addons["add_nodegroup_materials4"].preferences 
	change_nodegroup = context.object.change_nodegroup
		
	if change_nodegroup == True:
		preferences.used_default_nodegroup = False  
		context.object.change_nodegroup = False


def save_nodegroup(self, context):
	
	preferences = context.user_preferences.addons["add_nodegroup_materials4"].preferences 
	save_nodegroup = context.object.save_nodegroup
		
	if save_nodegroup == True:
		if preferences.material_nodegroup != '':
			bpy.ops.wm.save_userpref()
 
##################################################################################################
def register():
	
	if hasattr(bpy.types, panel_type):
		getattr(bpy.types, panel_type).append(draw_nodegroup_settings)
	else:
		bpy.utils.register_class(NodeMaterialPanel) 
	
	bpy.utils.register_class(NodeGroupMessageOperator)
	bpy.utils.register_class(NodeMaterialOperator)
	bpy.utils.register_class(NodeMaterialPreferences)
	
	bpy.types.Object.material_name = bpy.props.StringProperty(
		name = "Material Name",
		description = "Name for the new node group material",
		default = ''
	  )   
	bpy.types.Object.change_nodegroup = bpy.props.BoolProperty(
		name = "Select Node Group?",
		description = "Click to change to a different node group",
		default = False,
		update = change_nodegroups,
	  ) 
	bpy.types.Object.save_nodegroup = bpy.props.BoolProperty(
		name = "Save Default?",
		description = "Click to save the selected node group as default (Must be saved to the startup .blend)",
		default = False,
		update = save_nodegroup,
	  ) 
	bpy.types.Object.surface_volume = bpy.props.BoolProperty(
		name = "",
		description = "",
		default = False,
	  )

 
def unregister():
	
	if hasattr(bpy.types, panel_type):
		getattr(bpy.types, panel_type).remove(draw_nodegroup_settings)
	else:
		bpy.utils.unregister_class(NodeMaterialPanel)   

	bpy.utils.unregister_class(NodeGroupMessageOperator)
	bpy.utils.unregister_class(NodeMaterialOperator)
	bpy.utils.unregister_class(NodeMaterialPreferences)
		
 
	del bpy.types.Object.material_name
	del bpy.types.Object.change_nodegroup
	del bpy.types.Object.save_nodegroup
	del bpy.types.Object.surface_volume

if __name__ == "__main__":
	register()
